#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
//#include <sys/ioctl.h>

#include "board.h"
#include "mw.h"

#define FLASH_PAGE_SIZE                 ((uint16_t)0x400)
#define FLASH_WRITE_ADDR                (0x08000000 + (uint32_t)FLASH_PAGE_SIZE * 63)    // use the last KB for storage

uint8_t cliMode;
int16_t lookupRX[7];     //  lookup table for expo & RC rate

/*
 * Wrapper to test cli mode locally
 */
 
int main(int argc, char *argv[])
{
	void *p = (void *)(FLASH_WRITE_ADDR + FLASH_PAGE_SIZE * 8);
	setvbuf(stdin, NULL, _IONBF, 0);
//	fcntl(fileno(stdin), F_SETFL, O_NONBLOCK);
	system("stty raw -echo -ignbrk brkint");
	cliMode = 0;
	brk(p);
	cliProcess();
	system("stty cooked echo");
	exit(0);
}

#if 0
void featureClear(uint32_t mask)
{
}

void featureClearAll()
{
}

void featureSet(uint32_t mask)
{
}

void writeParams(void)
{
}
#endif

void FLASH_Lock() {
}
void FLASH_ClearFlag(uint32_t x) {
}
FLASH_Status FLASH_ErasePage(uint32_t Page_Address) {
	return FLASH_COMPLETE;
}
void FLASH_Unlock() {
}
FLASH_Status FLASH_ProgramWord(uint32_t Address, uint32_t Data) {
	return FLASH_COMPLETE;
}
void blinkLED(uint8_t num, uint8_t wait, uint8_t repeat) {
	printf("blinky blink!\r\n");
}


void systemReset(bool toBootloader)
{
	if (toBootloader)
		printf("Rebooting to bootloader...\r\n");
	else
		printf("Rebooting...\r\n");
}

uint8_t uartRead(void)
{
	uint8_t c = 0;
	read(fileno(stdin), &c, 1);
	if (c == 3) {
		fprintf(stderr,"^C\r\n");
		exit(1);
	}
	return c;
}

uint16_t uartAvailable(void)
{
	int i = 1;
//	ioctl(fileno(stdin), FIONREAD, &i);
	return !!i;
}

void uartWrite(uint8_t ch)
{
	write(fileno(stdout), &ch, 1);
}

void uartPrint(char *str)            
{
	write(fileno(stdout), str, strlen(str));
}

void delay(uint32_t ms)
{
	usleep(ms * 1000);
}
